// bonDriver_pt2wdm.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"

#pragma comment(lib,"winmm.lib")

#define	BAND_UHF	0
#define	BAND_CATV	1
#define	BAND_BS		4
#define	BAND_CS		5

#define	SPACE_UHF	0
#define	SPACE_CATV	1
#define	SPACE_BS	0
#define	SPACE_CS	1

static	const TCHAR	init_ext_name[]  = L".ini";
static	const TCHAR	setCh_ext_name[] = L".SetCh.txt";

static	const char	initDefMessage[] = {
	"[SET]\r\n"
	"OutLNB=0\t; LNBd(0:Ȃ,1:15V)\r\n"
	"AutoMake=1\t; `lݒt@CA(0:,1:L)\r\n"
};

static	const char	setChDefBT[] = {
	"; nfWUHF/CATV`lݒt@C\r\n"
	"$UHF\t0\t; UHFюMAKvȂ΃Z~RŖɂĂ\r\n"
	";$CATV\t1\t; P[uerMAKvȂ΃Z~ROėLɂĂ\r\n"
	";$VHF\tx\t; ̐ݒ͋@\܂\r\n"
	";[UHFݒ]sKvȃ`l̓Z~RŖɂĂ\r\n"
	"; `l\tband\tPT-ch\r\n"
};
static	const char	setChDefBT_CATV[] = {
	";[CATVݒ]sKvȃ`l̓Z~RŖɂĂ\r\n"
	"; `l\tband\tPT-ch\r\n"
};

static	const char	setChDefBS[] = {
	"; BS/CS`lݒt@C\r\n"
	"$BS\t0\t; BSюMAKvȂ΃Z~RŖɂĂ\r\n"
	"$CS110\t1\t; CS110юMAKvȂ΃Z~RŖɂĂ\r\n"
	";[BSݒ]sKvȃ`l̓Z~RŖɂĂ\r\n"
	"; `l\tband\tPT-ch\tTS-ID\r\n"
	"BS1/TS0 \t\t0\t 0\t0x4010\t;  0:BS1\r\n"
	"BS1/TS1 \t\t0\t 0\t0x4011\t;  1:BS-TBS\r\n"
	"BS3/TS0 \t\t0\t 1\t0x4030\t;  2:WOWOW\r\n"
	"BS3/TS1 \t\t0\t 1\t0x4031\t;  3:BSWp\r\n"
	"BS9/TS0 \t\t0\t 4\t0x4090\t;  4:BS11\r\n"
	"BS9/TS1 \t\t0\t 4\t0x4091\t;  5:X^[E`l\r\n"
	"BS9/TS2 \t\t0\t 4\t0x4092\t;  6:TwelV\r\n"
	"BS13/TS0\t\t0\t 6\t0x40d0\t;  7:BSe\r\n"
	"BS13/TS1\t\t0\t 6\t0x40d1\t;  8:BStWE181\r\n"
	"BS15/TS0\t\t0\t 7\t0x40f1\t;  9:NHK BS1\r\n"
	"BS15/TS1\t\t0\t 7\t0x40f2\t; 10:NHK BSv~A\r\n"
	"BS17/TS0\t\t0\t 8\t0x4310\t; 11:΍1\r\n"
	"BS17/TS1\t\t0\t 8\t0x4311\t; 12:΍2\r\n"
	";[CS110ݒ]sKvȃ`l̓Z~RŖɂĂ\r\n"
	"; `l\tband\tPT-ch\tTS-ID\r\n"
	"ND2     \t\t1\t12\t0x6020\t;  0:\r\n"
	"ND4     \t\t1\t13\t0x7040\t;  1:\r\n"
	"ND6     \t\t1\t14\t0x7060\t;  2:\r\n"
	"ND8     \t\t1\t15\t0x6080\t;  3:\r\n"
	"ND10    \t\t1\t16\t0x60a0\t;  4:\r\n"
	"ND12    \t\t1\t17\t0x70c0\t;  5:\r\n"
	"ND14    \t\t1\t18\t0x70e0\t;  6:\r\n"
	"ND16    \t\t1\t19\t0x7100\t;  7:\r\n"
	"ND18    \t\t1\t20\t0x7120\t;  8:\r\n"
	"ND20    \t\t1\t21\t0x7140\t;  9:\r\n"
	"ND22    \t\t1\t22\t0x7160\t; 10:\r\n"
	"ND24    \t\t1\t23\t0x7180\t; 11:\r\n"
};
static	struct{
	char	*bandName;
	int		bandCode;
}const bandNameTbl[] = {
	{"$UHF",BAND_UHF},{"$CATV" ,BAND_CATV},
	{"$BS" ,BAND_BS },{"$CS110",BAND_CS  }
};

static	const TCHAR	*terrestrialBandTbl[] = {L"ng",L"P[uTV"};
static	const TCHAR	*satelliteBandTbl[]   = {L"BS"    ,L"CS110"};

/**********************************************
 *                                            *
 *  CBonDrvPt2Wdm Class                       *
 *                                            *
 **********************************************/
/*
 *	CBonDrvPt2Wdm:RXgN^
 */
CBonDrvPt2Wdm::CBonDrvPt2Wdm(HINSTANCE hModule,HRESULT *phr)
	: m_hModule(hModule)
	, m_hPt2Wdm(INVALID_HANDLE_VALUE)
	, m_fBroadTerrestrial(true)
	, m_fOpen(false)
	, m_fInitFile(false)
	, m_fSetChFile(false)
	, m_fAutoMake(true)
	, m_iRcvUHF(0)
	, m_iRcvCATV(-1)
	, m_iRcvBS(0)
	, m_iRcvCS(-1)
	, m_iOutLNB(0)
	, m_fInitialize(false)
{
	HRESULT hr = E_OUTOFMEMORY;

	if(m_hMutex == NULL)	if((m_hMutex = CreateMutex(NULL,NULL,NULL)) == NULL)	goto	exit_01;
	if((m_iPtDevCount = PtDrvGetDevCount()) == 0)	goto	exit_01;	/* PTfoCXȂ? */
	if(!MakeFileName())	goto	exit_01;								/* t@C쐬s? */
	if(!Pt2WdmOpen())	goto	exit_01;								/* PTfoCXI[vs? */

	ZeroMemory(&m_sAuxBuf,sizeof(aux_buf));
	ZeroMemory(&m_sMsgBuf,sizeof(m_sMsgBuf));
	ZeroMemory(&m_sChUHF_BS,sizeof(m_sChUHF_BS));
	ZeroMemory(&m_sChCTV_CS,sizeof(m_sChCTV_CS));
	m_sAuxBuf.param.bufSize = sizeof(m_sAuxBuf.param.readBuf);
	m_sMsgBuf.size    = NUMELMS(m_sMsgBuf.msg);
	m_sChUHF_BS.count = NUMELMS(m_sChUHF_BS.ch);
	m_sChCTV_CS.count = NUMELMS(m_sChCTV_CS.ch);

	LoadInitialFileParam();
	LoadChanelFileParam();

	if((m_iRcvUHF == -1) && (m_iRcvCATV == -1) && (m_iRcvBS == -1) && (m_iRcvCS == -1))	goto exit_01;	/* LшȂ? */

	if(!m_fBroadTerrestrial && (m_iOutLNB != 0)){	/* LNBd? */
		BS_LNB_POWER lnbPower = BS_LNB_POWER_15V;
		PtDrvSetLnbPower(m_hPt2Wdm,lnbPower);
	}

	m_fInitialize = true;
	hr = S_OK;

exit_01:
	if(phr != NULL)	*phr = hr;
}

/*
 *	~CBonDrvPt2Wdm:fXgN^
 */
CBonDrvPt2Wdm::~CBonDrvPt2Wdm()
{
	HANDLE	hPt;

	if(m_fInitialize && m_fAutoMake){		/* ݒt@C쐬v? */
		if(m_fInitFile == false)	MakeInitFile();		/* ݒt@C쐬? */
		if(m_fSetChFile == false)	MakeSetChFile();	/* `lݒt@C쐬? */
	}

	if(!m_fBroadTerrestrial && (m_iOutLNB != 0)){		/* LNBd? */
		if(m_hPt2Wdm != INVALID_HANDLE_VALUE){
			if((hPt = PtDrvOpen(m_wcTunerOther)) != INVALID_HANDLE_VALUE){	/* ΂̃`[i[gp? */
				BS_LNB_POWER lnbPower = BS_LNB_POWER_OFF;
				PtDrvSetLnbPower(m_hPt2Wdm,lnbPower);
				PtDrvClose(hPt);
			}
		}
	}

	if(m_hPt2Wdm != INVALID_HANDLE_VALUE){
		PtDrvClose(m_hPt2Wdm);
		m_hPt2Wdm = INVALID_HANDLE_VALUE;
	}
}

/*
 *	CreateInstance:NX쐬
 */
CBonDrvPt2Wdm *CBonDrvPt2Wdm::CreateInstance(HINSTANCE hModule,HRESULT *phr)
{
	CBonDrvPt2Wdm *pNewObject = new CBonDrvPt2Wdm(hModule,phr);

	if(pNewObject == NULL){
		if(phr)	*phr = E_OUTOFMEMORY;
	}
	return pNewObject;

}

/******************************/
/*   IBonDriverI[oCh   */
/******************************/
/*
 *	OpenTuner:`[i[I[v
 */
const BOOL CBonDrvPt2Wdm::OpenTuner(void)
{

	if(m_hPt2Wdm == INVALID_HANDLE_VALUE)	return FALSE;
	PtDrvSetTunerSleep(m_hPt2Wdm,false);
	m_fOpen = true;
	return TRUE;
}

/*
 *	CloseTuner:`[i[N[Y
 */
void CBonDrvPt2Wdm::CloseTuner(void)
{

	PtDrvSetStreamEnable(m_hPt2Wdm,false);
	PtDrvSetTunerSleep(m_hPt2Wdm,true);
	m_fOpen = false;
}

/*
 *	SetChannel:`lݒ(IBonDriver)
 */
const BOOL CBonDrvPt2Wdm::SetChannel(const BYTE bCh)
{

	return TRUE;
}

/*
 *	GetSignalLevel:Mx擾
 */
const float CBonDrvPt2Wdm::GetSignalLevel(void)
{
	UINT	cn100,curAgc,maxAgc;


	PtDrvGetCnAgc(m_hPt2Wdm,&cn100,&curAgc,&maxAgc);
	return ((float )cn100) / 100;
}

/*
 *	WaitTsStream:Xg[҂
 */
const DWORD CBonDrvPt2Wdm::WaitTsStream(const DWORD dwTimeOut)
{
	bool	enable;
	DWORD	strTime,intTime;
	DWORD	timeOut;
	UINT	tsSize;

	if(m_hPt2Wdm == INVALID_HANDLE_VALUE)	return WAIT_FAILED;	/* foCXN[Y? */
	PtDrvGetStreamEnable(m_hPt2Wdm,&enable);					/* `[i[N[Y? */
	if(!enable){
		if(!m_fOpen)	return WAIT_ABANDONED;
		PtDrvSetStreamEnable(m_hPt2Wdm,true);
	}

	if((timeOut = dwTimeOut) == 0)	timeOut = 60 * 60 * 1000;	/* ^CAEg0Ȃ1 */
	for(strTime = timeGetTime(); ; SleepEx(10,FALSE)){
		PtDrvGetStreamSize(m_hPt2Wdm,&tsSize);					/* Mf[^擾 */
		if(tsSize != 0)	break;									/* Mf[^L? */
		intTime = timeGetTime() - strTime;
		if(intTime > timeOut)	break;							/* ^CAEg? */
	}
	return tsSize;
}

/*
 *	GetReadyCount:Xg[Mf[^
 */
const DWORD CBonDrvPt2Wdm::GetReadyCount(void)
{
	UINT	tsSize = 0;

	PtDrvGetStreamSize(m_hPt2Wdm,&tsSize);
	return tsSize;
}

/*
 *	GetTsStream:Xg[f[^擾
 */
const BOOL CBonDrvPt2Wdm::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	bool	enable;
	UINT	size    = *pdwSize;
	UINT	outSize = 0;

	if(m_hPt2Wdm == INVALID_HANDLE_VALUE)	return FALSE;	/* foCXN[Y? */
	if(!m_fOpen)	return FALSE;
	PtDrvGetStreamEnable(m_hPt2Wdm,&enable);				/* Xg[]? */
	if(!enable)	PtDrvSetStreamEnable(m_hPt2Wdm,true);

	PtDrvGetStreamData(m_hPt2Wdm,pDst,size,&outSize);		/* Xg[f[^捞 */
	*pdwSize = outSize;
	size = 0;
	PtDrvGetStreamSize(m_hPt2Wdm,&size);					/* cf[^L */
	*pdwRemain = (size != 0)? 1: 0;
	return (outSize != 0);
}

/*
 *	GetTsStream:Xg[f[^擾(كp[^)
 */
const BOOL CBonDrvPt2Wdm::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	DWORD	size;

	size = sizeof(m_sAuxBuf.strmBuf);
	GetTsStream(m_sAuxBuf.strmBuf,&size,pdwRemain);			/* obt@ */
	*ppDst = m_sAuxBuf.strmBuf;
	*pdwSize = size;
	return (size != 0);
}

/*
 *	PurgeTsStream:MXg[f[^
 */
void CBonDrvPt2Wdm::PurgeTsStream(void)
{

	PtDrvGetStreamFlush(m_hPt2Wdm);
}

/*******************************/
/*   IBonDriver2I[oCh   */
/*******************************/
/*
 *	GetTunerName:`[i[擾
 */
LPCTSTR CBonDrvPt2Wdm::GetTunerName(void)
{

	return m_wcTunerName;
}

/*
 *	IsTunerOpening:`[i[I[vԖ₢킹
 */
const BOOL CBonDrvPt2Wdm::IsTunerOpening(void)
{

	return FALSE;
}
	
/*
 *	EnumTuningSpace:`[i[ш於̎擾
 */
LPCTSTR CBonDrvPt2Wdm::EnumTuningSpace(const DWORD dwSpace)
{
	int		index;
	LPCTSTR	pSpace;

	if((dwSpace == m_iRcvUHF) || (dwSpace == m_iRcvBS))	index = 0;
	else if((dwSpace == m_iRcvCATV) || (dwSpace == m_iRcvCS))	index = 1;
	else	return NULL;
	pSpace = satelliteBandTbl[index];
	if(m_fBroadTerrestrial){
		pSpace = terrestrialBandTbl[index];
	}
	return pSpace;
}

/*
 *	EnumChannelName:`[i[Ll̎擾
 */
LPCTSTR CBonDrvPt2Wdm::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	ch_buf	*pChBuf;

	if((dwSpace == m_iRcvUHF) || (dwSpace == m_iRcvBS))	pChBuf = &m_sChUHF_BS;
	else if((dwSpace == m_iRcvCATV) || (dwSpace == m_iRcvCS))	pChBuf = &m_sChCTV_CS;
	else	return NULL;
	if(pChBuf->index <= (int )dwChannel)	return NULL;	/* `l݂Ȃ? */
	MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,pChBuf->ch[dwChannel].pMsg->msg,-1,m_wcChannelName,NUMELMS(m_wcChannelName));	/* jms -> unicode */
	return m_wcChannelName;
}

/*
 *	SetChannel:`[i[`lݒ(IBonDriver2)
 */
const BOOL CBonDrvPt2Wdm::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	UINT	channel;
	ch_buf	*pChBuf;
	TMCC_STATUS	tmcc;

	if((dwSpace == m_iRcvUHF) || (dwSpace == m_iRcvBS))	pChBuf = &m_sChUHF_BS;
	else if((dwSpace == m_iRcvCATV) || (dwSpace == m_iRcvCS))	pChBuf = &m_sChCTV_CS;
	else	return NULL;
	if(pChBuf->index < (int )dwChannel)	return FALSE;					/* `l݂Ȃ? */
	channel = pChBuf->ch[dwChannel].ptChannel;
	PtDrvSetStreamEnable(m_hPt2Wdm,false);								/* Xg[]֎~ */
	if(PtDrvSetFrequency(m_hPt2Wdm,channel) != NOERROR)	return FALSE;	/* `lݒ莸s? */
	SleepEx(60,FALSE);
	if(PtDrvGetTmcc(m_hPt2Wdm,&tmcc))	return FALSE;					/* fW^f[^s? */
	if(!m_fBroadTerrestrial)	PtDrvSetIdS(m_hPt2Wdm,pChBuf->ch[dwChannel].TsId);	/* BS/CS? */
	PtDrvSetStreamEnable(m_hPt2Wdm,true);								/* Xg[] */
	m_dSpace   = dwSpace;
	m_dChannel = dwChannel;
	return TRUE;
}
	
/*
 *	GetCurSpace:ݐݒ̃`[i[шR[h擾
 */
const DWORD CBonDrvPt2Wdm::GetCurSpace(void)
{

	return m_dSpace;
}

/*
 *	GetCurChannel:ݐݒ̃`[i[`l擾
 */
const DWORD CBonDrvPt2Wdm::GetCurChannel(void)
{

	return m_dChannel;
}

/*
 *	Release:CBonDrvPt2Wdm
 */
void CBonDrvPt2Wdm::Release(void)
{

	WaitForSingleObject(m_hMutex,INFINITE);
	delete	this;
	ReleaseMutex(m_hMutex);
}

/*******************************/
/*   wp[֐              */
/*******************************/
/*
 *	MakeFileName:PTfoCXI[v
 */
bool CBonDrvPt2Wdm::Pt2WdmOpen()
{
	int		board;
	int		tuner;
	const TCHAR	*pTunerName;

	pTunerName = PT_DEV_BT_NAME;
	if(!m_fBroadTerrestrial)	pTunerName = PT_DEV_BS_NAME;	/* BS/CS? */
	if(m_iTunerNumber >= 0){	/* `[iw肠? */
		board = m_iTunerNumber / 2;
		tuner = m_iTunerNumber % 2;
		if(board >= m_iPtDevCount)	return false;	/* ݂Ȃ`[i[? */
		StringCchPrintf(m_wcTunerName,NUMELMS(m_wcTunerName),pTunerName,++board,++tuner);
		m_hPt2Wdm = PtDrvOpen(m_wcTunerName);
	}else{						/* `[iI */
		for(board = 0; board++ < m_iPtDevCount; ){
			StringCchPrintf(m_wcTunerName,NUMELMS(m_wcTunerName),pTunerName,board,tuner = 1);
			if((m_hPt2Wdm = PtDrvOpen(m_wcTunerName)) != INVALID_HANDLE_VALUE)	return true;	/* `[i[1I[v? */
			StringCchPrintf(m_wcTunerName,NUMELMS(m_wcTunerName),pTunerName,board,tuner = 2);
			if((m_hPt2Wdm = PtDrvOpen(m_wcTunerName)) != INVALID_HANDLE_VALUE)	return true;	/* `[i[2I[v? */
		}
	}
	if(m_hPt2Wdm == INVALID_HANDLE_VALUE)	return false;
	if(tuner == 1)	tuner = 2;	/* ΂̃`[i[쐬 */
	else			tuner = 1;
	StringCchPrintf(m_wcTunerOther,NUMELMS(m_wcTunerOther),pTunerName,board,tuner);
	return true;
}

/*
 *	MakeFileName:Kvȃt@C쐬
 */
bool CBonDrvPt2Wdm::MakeFileName()
{
	int		n;
	int		len;
	int		pathLen;
	DWORD	length;
	int		tunerNumber;
	TCHAR	*pWc;
	bool	fBand;
	TCHAR	wcBugName[MAX_PATH];

	m_wcDllName[0]   = L'\0';
	m_wcPathName[0]  = L'\0';
	m_wcInitName[0]  = L'\0';
	m_wcSetChName[0] = L'\0';
	m_iTunerNumber  = -1;
	if((length = GetModuleFileName(m_hModule,m_wcDllName,NUMELMS(m_wcDllName))) == 0)	return false;	/* DLL̎捞s? */

	wcsncpy_s(m_wcPathName ,NUMELMS(m_wcPathName) ,m_wcDllName,length);
	wcsncpy_s(m_wcInitName ,NUMELMS(m_wcInitName) ,m_wcDllName,length);
	wcsncpy_s(m_wcSetChName,NUMELMS(m_wcSetChName),m_wcDllName,length);

	pWc = m_wcPathName + length - 1;		/* PATH쐬 */
	for(pathLen = (int )length; pathLen--; --pWc)	if(*pWc == L'\\')	break;
	if(pathLen < 0)	return false;		/* sPATH? */
	*(++pWc) = L'\0';

	pWc = m_wcInitName + length - 1;
	for(len = (int )length; len-- > pathLen; --pWc)	if(*pWc == L'.')	break;
	if(len < pathLen)	return false;	/* gqȂ? */
	fBand = true;
	switch(towupper(*(--pWc))){
	case	L'S':	m_fBroadTerrestrial = false; break;
	case	L'T':	m_fBroadTerrestrial = true;  break;
	default:
		tunerNumber = *pWc;
		if((tunerNumber >= L'0') && (tunerNumber <= L'9')){
			m_iTunerNumber = tunerNumber - L'0';
			switch(towupper(*(--pWc))){
			case	L'S':	m_fBroadTerrestrial = false; break;
			case	L'T':	m_fBroadTerrestrial = true;  break;
			default:		fBand = false; break;
			}
		}else	fBand = false;
		break;
	}
	if(fBand){		/* шʎw肠? */
		if(m_iTunerNumber >= 0)	--len;
		n = len - 1;
		pWc = m_wcInitName + n;
		*pWc++ = L'S'; *pWc++ = L'T';
		n = pWc - m_wcInitName;
		StringCchCopy(m_wcInitName + n,NUMELMS(m_wcInitName) - n,init_ext_name);		/* ݒt@C */
		n = len;
		StringCchCopy(m_wcSetChName + n,NUMELMS(m_wcSetChName) - n,setCh_ext_name);		/* `lݒt@C */
	}else{
		if(m_iTunerNumber >= 0)	--len;
		n = len;
		pWc = m_wcInitName + n;
		*pWc++ = L'-'; *pWc++ = L'S'; *pWc++ = L'T';
		n = pWc - m_wcInitName;
		StringCchCopy(m_wcInitName + n,NUMELMS(m_wcInitName) - n,init_ext_name);		/* ݒt@C */
		n = len;
		pWc = m_wcSetChName + n;
		*pWc++ = L'-'; *pWc++ = L'T';
		n = pWc - m_wcSetChName;
		StringCchCopy(m_wcSetChName + n,NUMELMS(m_wcSetChName) - n,setCh_ext_name);		/* `lݒt@C */
	}

	{			/* 2011.06.18 1oO΍ */
		StringCchCopy(wcBugName,NUMELMS(wcBugName),m_wcSetChName);
		n = len + 1;
		StringCchCopy(wcBugName + n,NUMELMS(wcBugName) - n,setCh_ext_name);
		if((_waccess(wcBugName,0) == 0) && (_waccess(m_wcSetChName,0) != 0)){			/* t@C𐳂̂ɕύX\? */
			_wrename(wcBugName,m_wcSetChName);
		}
	}

	return true;
}

/*
 *	LoadInitialFileParam:捞
 */
void CBonDrvPt2Wdm::LoadInitialFileParam()
{

	if(_waccess(m_wcInitName,0))	return;
	m_iOutLNB = (GetPrivateProfileInt(L"SET",L"OutLNB",m_iOutLNB,m_wcInitName) == 1)? 1: 0;
	m_fAutoMake = GetPrivateProfileInt(L"SET",L"AutoMake",m_fAutoMake,m_wcInitName) != 0;
	m_fInitFile = true;
}

/*
 *	LoadChanelFileParam:`lݒ捞
 */
void CBonDrvPt2Wdm::LoadChanelFileParam()
{

	m_sAuxBuf.param.hFile = INVALID_HANDLE_VALUE;
	if(m_wcSetChName[0] != L'\0'){
		m_sAuxBuf.param.hFile = CreateFile(m_wcSetChName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	}
	if(m_sAuxBuf.param.hFile == INVALID_HANDLE_VALUE){			/* `lݒt@CȂ? */
		if(m_fBroadTerrestrial){			/* nfW? */
			InitBtChanelParam();			/* nfW`llݒ */
			return;
		}
		m_sAuxBuf.param.fEof = true;		/* BS/CS */
		memcpy(m_sAuxBuf.param.readBuf,setChDefBS,sizeof(setChDefBS));
		m_sAuxBuf.param.size = sizeof(setChDefBS) - 1;
		m_sAuxBuf.param.fEof = true;
	}else{
		m_fSetChFile = true;				/* ݒt@CǍ */
	}
	LoadChanelParam();						/* `l捞 */
	if(m_sAuxBuf.param.hFile != INVALID_HANDLE_VALUE)	CloseHandle(m_sAuxBuf.param.hFile);
}

/*
 *	LoadChanelParam:`lݒ捞
 */
void CBonDrvPt2Wdm::LoadChanelParam()
{
	long	space;
	int		param;
	ch_buf	*pChBuf;
	ch_dat	**ppChDat;
	ch_dat	*pUhf;
	ch_dat	*pCtv;

	m_iRcvUHF  = -1;
	m_iRcvCATV = -1;
	m_iRcvBS   = -1;
	m_iRcvCS   = -1;

	m_sChUHF_BS.index = 0;
	m_sChCTV_CS.index = 0;
	pUhf = m_sChUHF_BS.ch;
	pCtv = m_sChCTV_CS.ch;
	param = 4;
	if(m_fBroadTerrestrial)	param = 3;					/* nfW? */
	while(GetLineParam()){
		if(m_sAuxBuf.param.argc < 2)	continue;
		if((space = strtol(m_sAuxBuf.param.argv[1],NULL,0)) < 0)	continue;	/* ш */
		if(m_sAuxBuf.param.argv[0][0] == '$'){			/* шݒ? */
			for(int i = 0; i < NUMELMS(bandNameTbl); ++i){
				if(strcmp(m_sAuxBuf.param.argv[0],bandNameTbl[i].bandName))	continue;
				switch(bandNameTbl[i].bandCode){
				case	BAND_UHF:	m_iRcvUHF  = space; break;
				case	BAND_CATV:	m_iRcvCATV = space; break;
				case	BAND_BS:	m_iRcvBS   = space; break;
				case	BAND_CS:	m_iRcvCS   = space; break;
				default:	break;
				}
				break;
			}
			continue;
		}
		if(m_sAuxBuf.param.argc < param)	continue;	/* p[^s? */
		if((space == m_iRcvUHF) || (space == m_iRcvBS)){		/* UHF or BS? */
			pChBuf  = &m_sChUHF_BS;
			ppChDat = &pUhf;
		}else if((space == m_iRcvCATV) || (space == m_iRcvCS)){	/* CATV or CS? */
			pChBuf  = &m_sChCTV_CS;
			ppChDat = &pCtv;
		}else	continue;
		if(pChBuf->index >= pChBuf->count)	continue;	/* `lI[o[? */
		(*ppChDat)->pMsg = PutMsgBuf(m_sAuxBuf.param.argv[0]);				/* `l */
		(*ppChDat)->ptChannel = (BYTE )strtol(m_sAuxBuf.param.argv[2],NULL,0);	/* PT`lԍ */
		if(m_sAuxBuf.param.argc > 3){
			(*ppChDat)->TsId = (WORD )strtol(m_sAuxBuf.param.argv[3],NULL,0);	/* TS ID */
		}
		++(pChBuf->index);
		++(*ppChDat);
	}
}

/*
 *	InitBtChanelParam:nfW`llݒ
 */
void CBonDrvPt2Wdm::InitBtChanelParam()
{
	int		max;
	ch_dat	*pUhf;
	ch_dat	*pCtv;
	int		frequency;
	char const *pChName;

	m_sChUHF_BS.count = NUMELMS(m_sChUHF_BS.ch);
	m_sChCTV_CS.count = NUMELMS(m_sChCTV_CS.ch);
	m_sChUHF_BS.index = 0;
	m_sChCTV_CS.index = 0;
	pUhf = m_sChUHF_BS.ch;
	pCtv = m_sChCTV_CS.ch;
	PtDrvGetChannelMax(m_hPt2Wdm,&max);		/* S`l */
	for(UINT ch = 0; ch < (UINT )max; ++ch){
		PtDrvGetChannelInfo(m_hPt2Wdm,ch,&frequency,&pChName);
		if(*pChName != 'C'){		/* UHF? */
			if(m_sChUHF_BS.count <= m_sChUHF_BS.index)	continue;	/* I[o[? */
			pUhf->ptChannel = ch;
			pUhf->pMsg = PutMsgBuf(pChName);
			++m_sChUHF_BS.index;
			++pUhf;
		}else{						/* CATV */
			if(m_sChCTV_CS.count <= m_sChCTV_CS.index)	continue;	/* I[o[? */
			pCtv->ptChannel = ch;
			pCtv->pMsg = PutMsgBuf(pChName);
			++m_sChCTV_CS.index;
			++pCtv;
		}
	}
}

/*
 *	GetLineParam:ݒf[^1s捞
 */
bool	CBonDrvPt2Wdm::GetLineParam()
{
	int		c;
	int		index;
	int		line;
	DWORD	nBytesRead;
	BYTE	*pDst;

	m_sAuxBuf.param.argc      = 0;
	m_sAuxBuf.param.lineSize  = 0;
	m_sAuxBuf.param.fContinue = false;
	m_sAuxBuf.param.fNewLine  = false;
	ZeroMemory(m_sAuxBuf.param.argv,sizeof(m_sAuxBuf.param.argv));
	index = m_sAuxBuf.param.index;
	for( ; ; ){
		if(m_sAuxBuf.param.size == 0){						/* Ǎ݃f[^Ȃ? */
			if(m_sAuxBuf.param.fEof){						/* t@Cf[^Ȃ? */
				if(m_sAuxBuf.param.lineSize == 0)	break;	/* pf[^Ȃ? */
			}else{											/* t@CǍ */
				ReadFile(m_sAuxBuf.param.hFile,m_sAuxBuf.param.readBuf,m_sAuxBuf.param.bufSize,&nBytesRead,NULL);
				m_sAuxBuf.param.fEof = (m_sAuxBuf.param.bufSize != nBytesRead);	/* SǍ? */
				m_sAuxBuf.param.size = nBytesRead;
				m_sAuxBuf.param.index = 0;
			}
		}
		if(!m_sAuxBuf.param.fContinue){						/* 擪? */
			for( ; index < m_sAuxBuf.param.size; ++index){
				if(m_sAuxBuf.param.readBuf[index] > ' ')	break;	/* Lo? */
			}
			m_sAuxBuf.param.index = index;
			if(index >= m_sAuxBuf.param.size){				/* LȂ? */
				m_sAuxBuf.param.size = 0;					/* Ǎ */
				continue;
			}
		}
		if(!m_sAuxBuf.param.fNewLine){						/* 1so */
			line = 0;
			pDst = m_sAuxBuf.param.lineBuf + line;
			for(; index < m_sAuxBuf.param.size; ++index){
				c = m_sAuxBuf.param.readBuf[index];
				if((c == '\r') || (c == '\n'))	break;		/* s? */
				*pDst++ = c;
				if(++line < (sizeof(m_sAuxBuf.param.lineBuf) - 1))	continue;
				m_sAuxBuf.param.fNewLine = true;			/* sobt@I[o[! */
				break;
			}
			m_sAuxBuf.param.index = index;
			if(index >= m_sAuxBuf.param.size){				/* sȂ? */
				m_sAuxBuf.param.size = 0;					/* Ǎ */
				continue;
			}
			m_sAuxBuf.param.lineSize = line;				/* 1s */
		}
		if(m_sAuxBuf.param.fNewLine){						/* 1s΂ */
			for( ; index < m_sAuxBuf.param.size; ++index){
				c = m_sAuxBuf.param.readBuf[index];
				if((c == '\r') || (c == '\n'))	break;		/* s? */
			}
			m_sAuxBuf.param.index = index;
			if(index >= m_sAuxBuf.param.size){				/* sȂ? */
				m_sAuxBuf.param.size = 0;					/* Ǎ */
				continue;
			}
		}
		for(pDst = m_sAuxBuf.param.lineBuf,line = m_sAuxBuf.param.lineSize; line; --line){
			if(*pDst++ == ';')	break;						/* Rg? */
		}
		if((line = m_sAuxBuf.param.lineSize - line) == 0){	/* Lf[^Ȃ? */
			m_sAuxBuf.param.fContinue = false;
			m_sAuxBuf.param.fNewLine  = false;
			m_sAuxBuf.param.lineSize  = 0;					/* 2011.07.20 2oOC */
			continue;
		}
		m_sAuxBuf.param.lineSize = line;
		m_sAuxBuf.param.lineBuf[line] = '\0';
		pDst = m_sAuxBuf.param.lineBuf;
		m_sAuxBuf.param.argv[m_sAuxBuf.param.argc] = (char *)pDst;
		++m_sAuxBuf.param.argc;
		bool	flag = false;
		for(int n = line; n--; ++pDst){
			if(!flag){
				if(*pDst > ' ')	continue;
				*pDst = '\0';								/* ؂蕶o! */
				if(m_sAuxBuf.param.argc >= NUMELMS(m_sAuxBuf.param.argv))	break;	/* p[^I[o[? */
				flag = true;
			}else{
				if(*pDst <= ' ')	continue;
				m_sAuxBuf.param.argv[m_sAuxBuf.param.argc] = (char *)pDst;	/* ̃p[^ */
				++m_sAuxBuf.param.argc;
				flag = false;
			}
		}
		return true;
	}
	return false;
}


/*
 *	PutMsgBuf:bZ[Wi[
 */
const msg_dat	*CBonDrvPt2Wdm::PutMsgBuf(const char *pMsg)
{
	int		len;
	msg_dat	*pBuf;

	if((len = strlen(pMsg)) > 255)	len = 255;
	if((m_sMsgBuf.size - m_sMsgBuf.index) < (int )(len + sizeof(msg_dat)))	return NULL;
	pBuf = (msg_dat *)(m_sMsgBuf.msg + m_sMsgBuf.index);
	pBuf->length = len;
	CopyMemory(pBuf->msg,pMsg,len);
	pBuf->msg[len] = '\0';
	m_sMsgBuf.index += (len + sizeof(msg_dat));
	return pBuf;
}

/*
 *	MakeInitFile:ݒt@C쐬
 */
void	CBonDrvPt2Wdm::MakeInitFile()
{
	HANDLE	hFile;
	DWORD	nBytesWrite;

	if((hFile = CreateFile(m_wcInitName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)	return;
	WriteFile(hFile,initDefMessage,sizeof(initDefMessage) - 1,&nBytesWrite,NULL);
	CloseHandle(hFile);
}

/*
 *	MakeSetChFile:`lݒt@C쐬
 */
void	CBonDrvPt2Wdm::MakeSetChFile()
{
	int		index;
	int		len;
	int		space;
	HANDLE	hFile;
	DWORD	nBytesWrite;
	ch_dat	*pChDat;
	char	msg[256];

	if((hFile = CreateFile(m_wcSetChName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)	return;
	if(!m_fBroadTerrestrial){	/* BS/CS? */
		WriteFile(hFile,setChDefBS,sizeof(setChDefBS) - 1,&nBytesWrite,NULL);
	}else{						/* nfW */
		WriteFile(hFile,setChDefBT,sizeof(setChDefBT) - 1,&nBytesWrite,NULL);			/* UHF */
		space = m_iRcvUHF;
		if(space < 0)	space = SPACE_UHF;
		pChDat = m_sChUHF_BS.ch;
		for(index = 0; index < m_sChUHF_BS.index; ++index,++pChDat){
			len = sprintf_s(msg,sizeof(msg),"%s\t\t\t%d\t%3d\t; %2d:\r\n",pChDat->pMsg->msg,space,pChDat->ptChannel,index);
			WriteFile(hFile,msg,len,&nBytesWrite,NULL);
		}
		WriteFile(hFile,setChDefBT_CATV,sizeof(setChDefBT_CATV) - 1,&nBytesWrite,NULL);	/* CATV */
		space = m_iRcvCATV;
		if(space < 0)	space = SPACE_CATV;
		pChDat = m_sChCTV_CS.ch;
		for(index = 0; index < m_sChCTV_CS.index; ++index,++pChDat){
			len = sprintf_s(msg,sizeof(msg),"%s\t\t\t%d\t%3d\t; %2d:\r\n",pChDat->pMsg->msg,space,pChDat->ptChannel,index);
			WriteFile(hFile,msg,len,&nBytesWrite,NULL);
		}
	}
	CloseHandle(hFile);
}

